import { FileValue } from "./file-param";
import { FilesValue } from "./files-param";
export interface IResultFileDto {
    FileName: string;
    FileExt: string;
    FileSize: number;
    FileId: string;
    Url: string;
}
export interface IResultDto {
    ConversionCost: number;
    Files: IResultFileDto[];
}
export default class Result {
    private readonly dto;
    constructor(dto: IResultDto);
    get duration(): number;
    get files(): IResultFileDto[];
    toParamFile(idx?: number): FileValue;
    toParamFiles(): FilesValue;
    uploadToS3(region: string, bucket: string, accessKeyId: string, secretAccessKey: string): Promise<Response>[];
}
//# sourceMappingURL=result.d.ts.map